import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.reportdesigner.ReportAPI.ChartObject;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportElements.ReportChartObject;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.IChart;
import quadbase.reportdesigner.util.IChartModifier;

public class ExampleIChartModifier extends Applet {

	static final long serialVersionUID = 1;

	public static void main(String[] args) {
		try {
			ExampleIChartModifier chart = new ExampleIChartModifier();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", chart.doIChartModifier(frame));
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void init() {
		setLayout(new BorderLayout());
		add("Center", doIChartModifier(this));
	}

	Component doIChartModifier(Object parent)  {

		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);

		// Template Location
		String templateLocation = "IChartModifier.pak";

		// Create QbReport object from template
		QbReport report = new QbReport(parent, templateLocation);
		
		// Apply IChartModifier class to all charts to turn background to white
		ReportChartObject[] reportCharts = report.getReportChartObjects();
		for (int i = 0; i < reportCharts.length; ++i)
		{
			reportCharts[i].setChartModifier(new ModifyChart());
		}

		// Show report in Viewer
		return (new Viewer().getComponent(report));
	}

	// Change background to white
	public class ModifyChart implements IChartModifier
	{
		public IChart modifyChart(Object chartInfo) {
			ChartObject chart = new ChartObject(chartInfo);  // Get actual ChartObject
			chart.gethCanvas().setBackgroundColor(Color.white);
			return chart;
		}
	}
}
